#define INCL_WIN
#define INCL_DOS
#define INCL_GPI
#include <os2.h>

#include "npunzip.h"

#include <string.h>
#include <stdlib.h>
#include <sys\types.h>
#include <sys\stat.h>
#include "process.h"

#ifndef _NPAPI_H_
#include "npapi.h"
#endif

#ifndef _NPUPP_H_
#include "npupp.h"
#endif
#include "unzip.h"

typedef struct _USERRECORD
{
  RECORDCORE  recordCore;
  PCHAR       filename;
  ULONG       file_size;
  ULONG       ea_size;
  ULONG       acl_size;
  CHAR        f1[255];
} USERRECORD, *PUSERRECORD;
PUSERRECORD      pUserRecord;
RECORDINSERT     recordInsert;
HWND             hwnd_cont;

void invalidate_container(HWND hwndCnr)
{
  USHORT cNumRecord;             /* Number of records to be removed     */
  USHORT fRemoveRecord;          /* Container message attributes        */

 /**********************************************************************/
 /*  Zero means remove all records.                                    */
 /**********************************************************************/
 cNumRecord = 0;

 /**********************************************************************/
 /*  Specify attributes to invalidate the container                    */
 /*  and free the memory.                                              */
 /**********************************************************************/
 fRemoveRecord = CMA_FREE | CMA_INVALIDATE;
 WinSendMsg(hwndCnr,
            CM_REMOVERECORD,

            NULL,
            MPFROM2SHORT(
                          cNumRecord,
                          fRemoveRecord));

}
int _System getdir(char *filename,cdir_file_hdr *p,int easize,int aclsize)
{
   USHORT           nRecords = 1;
   ULONG            cbRecordData;

   cbRecordData = (LONG) (sizeof(USERRECORD) - sizeof(RECORDCORE));
   pUserRecord = (PUSERRECORD) WinSendDlgItemMsg(hwnd_cont,ID_CONTAINER,
                                                 CM_ALLOCRECORD, MPFROMLONG(cbRecordData) ,
                                                 MPFROMSHORT(nRecords));
   pUserRecord->recordCore.cb = sizeof(RECORDCORE);              /*RBS*/
   pUserRecord->recordCore.pszText = filename;
   pUserRecord->recordCore.pszIcon = filename;
   pUserRecord->recordCore.pszName = filename;
   pUserRecord->recordCore.hptrIcon = 0;
   strcpy(pUserRecord->f1,filename);
   pUserRecord->filename = pUserRecord->f1;
   pUserRecord->file_size = p->ucsize;
   pUserRecord->ea_size   = easize;
   pUserRecord->acl_size  = aclsize;

   recordInsert.cb = sizeof(RECORDINSERT);                   /*RBS*/
   recordInsert.pRecordParent= NULL;
   recordInsert.pRecordOrder = (PRECORDCORE)CMA_END;
   recordInsert.zOrder = CMA_TOP;
   recordInsert.cRecordsInsert = 1;
   recordInsert.fInvalidateRecord = TRUE;

   WinSendDlgItemMsg(hwnd_cont,ID_CONTAINER, CM_INSERTRECORD,
                    (PRECORDCORE)pUserRecord, &recordInsert);
   return 0;
}

//
// Instance state information about the plugin.
//
// *Developers*: Use this struct to hold per-instance
//               information that you'll need in the
//               various functions in this file.
//

typedef struct _PluginInstance
{
    NPWindow*       fWindow;
    HWND            hWnd;
    uint16          fMode;
    NPP             npp;
    ULONG           total;
    ULONG           reste;
    CHAR            filename[256];
    FILE            *fichout;
    HMQ             hmq;
    PFNWP           lpfnOldWndProc;
    NPSavedData*    pSavedInstanceData;
    struct _PluginInstance *pNext;
} PluginInstance;

int32 STREAMBUFSIZE = 32767;        // If we are reading from a file in
                                    // NP_ASFILE mode, we can take any size
                                    // stream in our write call (since we
                                    // ignore it)

MRESULT APIENTRY
SubClassFunc(HWND hWnd,ULONG Message,MPARAM wParam, MPARAM lParam);


HMODULE DLLInstance;

#if defined ( __cplusplus )
extern "C" {
#endif

/* _CRT_init is the C run-time environment initialization function.         */
/* It will return 0 to indicate success and -1 to indicate failure.         */
   int _CRT_init(void);

/* __ctordtorInit calls the C++ run-time constructors for static objects.   */
   void __ctordtorInit(void);

/* __ctordtorTerm calls the C++ run-time destructors for static objects.    */
   void __ctordtorTerm(void);

#ifdef   STATIC_LINK

/* _CRT_term is the C run-time environment termination function.            */
/* It only needs to be called when the C run-time functions are statically  */
/* linked.                                                                  */
   void _CRT_term(unsigned long);

#else

/* A clean up routine registered with DosExitList must be used if runtime   */
/* calls are required at exit AND the runtime is dynamically linked.  This  */
/* will guarantee that this clean up routine is run before the library DLL  */
/* is terminated.  Do any application housekeeping in cleanup()             */
    static void _System cleanup(ULONG ulReason);

#endif


#if defined ( __cplusplus )
}
#endif


#if defined ( __cplusplus )
extern "C"
#endif
unsigned long _System _DLL_InitTerm(unsigned long hModule, unsigned long
                                    ulFlag)
{
    DLLInstance = (HMODULE) hModule;
    switch (ulFlag)
    {
        case 0:
            if ( _CRT_init() == -1 )
            {
                return(0UL);
            }
#if defined ( __cplusplus )
            __ctordtorInit();
#endif

#ifndef  STATIC_LINK

         /*******************************************************************/
         /* A DosExitList routine must be used to clean up if runtime calls */
         /* are required at exit and the runtime is dynamically linked.     */
         /*******************************************************************/

            DosExitList(0x0000FF00|EXLST_ADD, cleanup);
#endif
            break;
        case 1:

#if defined ( __cplusplus )
            __ctordtorTerm();
#endif

#ifdef  STATIC_LINK
            _CRT_term(0UL);
#endif
            break;
    }

    return 1;
}

#ifndef  STATIC_LINK
static void cleanup(ULONG ulReason)
{
   /* do any DLL cleanup here if needed AND if dynamically linked to the */
   /* C Runtime libraries                                                */
   DosExitList(EXLST_EXIT, cleanup);   /* remember to unlink ourselves   */
   return ;
}
#endif

// A plugin instance typically will subclass the plugin's client window, so
// it can get Windows messages, (such as paint, palettechanged, keybd, etc).
// To do work associated with a specific plugin instance the WndProc which
// receives the Windows messages, (named "SubClassFunc" herein), needs access
// to the "This" (PluginInstance*) ptr.
// If the plugin wants all the keyboard messages, it will have to
// create a frame window with it's own accelerator table (even it it is empty)
// and insure that that frame tracks the plugin window that Navigator creates,
// otherwise the Navigator Accelerators will interfere with the WM_CHARs
// that the plugin windows receive...

// When Navigator registers the plugin client's window class, (the class for
// the window passed in NPP_SetWindow()), Navigator reserves 4
// "extra" window bytes for the plugins use... at QWL_USER
// Associate the hWnd with pInstance by setting the hWnd member of the
// PluginInstance struct.
static void AssociateInstance(HWND hWnd, PluginInstance* pInstance)
{
    BOOL rc;

    pInstance->hWnd = hWnd;     // redundant, but usefull to get hwnd from
                                // pinstance later.
    rc = WinSetWindowULong(hWnd, QWL_USER, (ULONG)pInstance);
}

// Find the PluginInstance associated with this hWnd and return it
static PluginInstance* GetInstance(HWND hWnd)
{
    return (PluginInstance*)WinQueryWindowULong(hWnd, QWL_USER);
}

MRESULT EXPENTRY NPLoadProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   HPS    hps;
   RECTL  rcl;
   POINTL endpoint;
   POINTL pos;
   ULONG  total;
   ULONG  reste;
   CHAR   tmp[20];

   switch(msg)
    {
       case WM_USER:
            total    = (ULONG)mp1;
            reste    = (ULONG)mp2;

            WinQueryWindowRect(WinWindowFromID(hwnd,ID_PROGRESS),&rcl);
            hps = WinGetPS(WinWindowFromID(hwnd,ID_PROGRESS));
            if (total > 10000)
              {
                 total = total / 10000;
                 reste = reste / 10000;
              }

            pos.x = (rcl.xRight-5*10)/2;
            pos.y = 1;
            GpiMove(hps,&pos);
            endpoint.x = pos.x+5*10;
            endpoint.y = rcl.yTop-2;
            GpiSetColor(hps, CLR_PALEGRAY);
            GpiBox(hps, DRO_FILL, &endpoint, 0L, 0L);

            pos.x = 1;
            pos.y = 1;
            GpiMove(hps,&pos);
            endpoint.x = (((total-reste) * rcl.xRight) / total)-2;
            endpoint.y = rcl.yTop-2;
            GpiSetColor(hps, CLR_RED);
            GpiBox(hps, DRO_FILL, &endpoint, 0L, 0L);

            GpiSetColor(hps, CLR_BLACK);
            pos.x = (rcl.xRight-10*5)/2;
            pos.y = (rcl.yTop-10)/2;
            sprintf(tmp,"%3d %c",((total-reste)*100)/total,'%');
            GpiMove(hps,&pos);
            GpiCharString(hps,strlen(tmp),tmp);
            WinReleasePS(hps);
            break;
       case WM_ERASEBACKGROUND:
             return (MRESULT) TRUE;
            break;
      default:
              return WinDefDlgProc(hwnd, msg, mp1, mp2);
              break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}
PRECORDCORE QuerySelection(PRECORDCORE pStartRecord,HWND hwndCnr)
{
  if ( !pStartRecord )
    pStartRecord = (PRECORDCORE)CMA_FIRST;

  return (PRECORDCORE)WinSendMsg(hwndCnr, CM_QUERYRECORDEMPHASIS,
                                 MPFROMLONG(pStartRecord), MPFROMSHORT(CRA_SELECTED));
}
MRESULT EXPENTRY NPUnzipProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
   PRECORDCORE      pRecord;
   PFIELDINFO       pFieldInfo, firstFieldInfo;
   FIELDINFOINSERT  fieldInfoInsert;
   PFIELDINFOINSERT pFieldInfoInsert;
   CNRINFO          cnrinfo;
   ULONG            ulCnrAttributes;
   PluginInstance   *This;
   UzpVer           *pVersion;
   char             version[40];
   char             *cpinclude[2];
   char             *cpexclude[2];
   char             include[20];
   char             exclude[20];
   int              rc;

   static           int argc;
   static           unsigned char *argv[7];
   USERRECORD       *pCnrData;
   char             unzpath[255];
   struct stat      stat_str;

   switch(msg)
    {
       case WM_INITDLG:
            hwnd_cont = hwnd;
            This = (PluginInstance *)mp2;
            pVersion = UzpVersion();
            sprintf(version,"Based on winzip ver %d.%d patch level : %d",
                             pVersion->os2dll.major,
                             pVersion->os2dll.minor,
                             pVersion->os2dll.patchlevel);
            WinSetDlgItemText(hwnd,ID_ZIPVER,version);
            WinSetDlgItemText(hwnd,ID_ZIPFILE,This->filename);
            WinSetDlgItemText(hwnd,ID_INCMASK,"*");
            pFieldInfo = (PFIELDINFO) WinSendDlgItemMsg(hwnd, ID_CONTAINER,
                                                        CM_ALLOCDETAILFIELDINFO,MPFROMLONG(4), NULL);

            firstFieldInfo = pFieldInfo;

            pFieldInfo->cb = sizeof(FIELDINFO);
            pFieldInfo->flData = CFA_STRING | CFA_HORZSEPARATOR;


            pFieldInfo->flTitle = 0;
            pFieldInfo->pTitleData = (PVOID) "Filename";
            pFieldInfo->offStruct = 56;
            pFieldInfo = pFieldInfo->pNextFieldInfo;

            pFieldInfo->cb = sizeof(FIELDINFO);
            pFieldInfo->flData = CFA_ULONG  | CFA_HORZSEPARATOR | CFA_RIGHT |
                                 CFA_SEPARATOR;
            pFieldInfo->flTitle = CFA_CENTER;
            pFieldInfo->pTitleData =  (PVOID) "File size";
            pFieldInfo->offStruct = 60;
            pFieldInfo = pFieldInfo->pNextFieldInfo;

            pFieldInfo->cb = sizeof(FIELDINFO);
            pFieldInfo->flData = CFA_ULONG  | CFA_HORZSEPARATOR | CFA_RIGHT |
                                 CFA_SEPARATOR;
            pFieldInfo->flTitle = CFA_CENTER;
            pFieldInfo->pTitleData = (PVOID) "EA Size";
            pFieldInfo->offStruct = 64;
            pFieldInfo = pFieldInfo->pNextFieldInfo;

            pFieldInfo->cb = sizeof(FIELDINFO);
            pFieldInfo->flData = CFA_ULONG  | CFA_HORZSEPARATOR | CFA_RIGHT |
                                 CFA_SEPARATOR;
            pFieldInfo->flTitle = CFA_CENTER;
            pFieldInfo->pTitleData = (PVOID) "ACL Size";
            pFieldInfo->offStruct = 68;


            fieldInfoInsert.cb = (ULONG)(sizeof(FIELDINFOINSERT));
            fieldInfoInsert.pFieldInfoOrder = (PFIELDINFO)CMA_FIRST;
            fieldInfoInsert.cFieldInfoInsert = 4;
            fieldInfoInsert.fInvalidateFieldInfo = TRUE;

            pFieldInfoInsert = &fieldInfoInsert;

            WinSendDlgItemMsg(hwnd,ID_CONTAINER, CM_INSERTDETAILFIELDINFO,
                              MPFROMP(firstFieldInfo),
                              MPFROMP(pFieldInfoInsert));
            cnrinfo.flWindowAttr  = CV_DETAIL|CA_DETAILSVIEWTITLES;
            WinSendDlgItemMsg(hwnd,ID_CONTAINER,CM_SETCNRINFO,MPFROMP(&cnrinfo),
                              MPFROMLONG(CMA_FLWINDOWATTR));
            cnrinfo.xVertSplitbar  = 400;
            cnrinfo.pFieldInfoLast = firstFieldInfo;
            WinSendDlgItemMsg(hwnd,ID_CONTAINER,CM_SETCNRINFO,MPFROMP(&cnrinfo),
                              MPFROMLONG(CMA_XVERTSPLITBAR|CMA_PFIELDINFOLAST));
            WinQueryDlgItemText(hwnd,ID_INCMASK,sizeof(include),include);
            WinQueryDlgItemText(hwnd,ID_EXMASK,sizeof(exclude),exclude);

            cpinclude[0] = include;
            cpinclude[1] = NULL;

            cpexclude[0] = exclude;
            cpexclude[1] = NULL;
            rc = UzpFileTree("\\tmp.zip",
                             getdir,
                             cpinclude,
                             cpexclude);
            break;
       case WM_COMMAND:
            switch(COMMANDMSG(&msg)->cmd)
             {
               case ID_CHGMASK:
                    invalidate_container( WinWindowFromID(hwnd,ID_CONTAINER) );
                    WinQueryDlgItemText(hwnd,ID_INCMASK,sizeof(include),include);
                    WinQueryDlgItemText(hwnd,ID_EXMASK,sizeof(exclude),exclude);

                    cpinclude[0] = include;
                    cpinclude[1] = NULL;

                    cpexclude[0] = exclude;
                    cpexclude[1] = NULL;
                    rc = UzpFileTree("\\tmp.zip",
                                     getdir,
                                     cpinclude,
                                     cpexclude);
                    break;
               case DID_CANCEL:
                    WinDismissDlg(hwnd,TRUE);
                    break;
               case ID_UNZIP:
                    WinQueryDlgItemText(hwnd,ID_UNZPATH,sizeof(unzpath),unzpath);
                    if (stat(unzpath,&stat_str) != 0)
                      {
                         WinMessageBox(HWND_DESKTOP,hwnd,"Unzip directory not found","Unzip Error",0,MB_OK);
                         return (MRESULT) TRUE;
                      }
                    pRecord = QuerySelection(NULL,WinWindowFromID(hwnd,ID_CONTAINER));
                    while( pRecord )
                     {
                       argc    = 5;
                       argv[0] = "npunzip.dll";
                       argv[1] = "\\tmp.zip";
                       pCnrData = (USERRECORD *)pRecord;
                       argv[2] = pCnrData->filename;
                       argv[3] = "-d";
                       argv[4] = unzpath;
                       argv[5] = "\0\0";
                       argv[6] = "\0\0";
                       rc = UzpMain( argc, &argv[0] );
                       pRecord = QuerySelection(pRecord,WinWindowFromID(hwnd,ID_CONTAINER));
                     }
                    WinMessageBox(HWND_DESKTOP,hwnd,"Files extracted !!!","NPUNZIP",0,MB_OK);
                    break;
               case ID_UNZIPALL:
                    WinQueryDlgItemText(hwnd,ID_UNZPATH,sizeof(unzpath),unzpath);
                    if (stat(unzpath,&stat_str) != 0)
                      {
                         WinMessageBox(HWND_DESKTOP,hwnd,"Unzip directory not found","Unzip Error",0,MB_OK);
                         return (MRESULT) TRUE;
                      }
                    argc    = 5;
                    argv[0] = "npunzip.dll";
                    argv[1] = "\\tmp.zip";
                    argv[2] = "*.*";
                    argv[3] = "-d";
                    argv[4] = unzpath;
                    argv[5] = "\0\0";
                    argv[6] = "\0\0";
                    rc = UzpMain( argc, &argv[0] );
                    WinMessageBox(HWND_DESKTOP,hwnd,"Files extracted !!!","NPUNZIP",0,MB_OK);
                    break;
             }
            return (MRESULT) TRUE;
            break;
       case WM_ERASEBACKGROUND:
            return (MRESULT) TRUE;
            break;
      default:
              return WinDefDlgProc(hwnd, msg, mp1, mp2);
              break;
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}
//----------------------------------------------------------------------------
// NPP_Initialize:
//----------------------------------------------------------------------------
NPError NPP_Initialize(void)
{
    // do your one time initialization here, such as dynamically loading
    // dependant DLLs
    return NPERR_NO_ERROR;
}


//----------------------------------------------------------------------------
// NPP_Shutdown:
//----------------------------------------------------------------------------
void NPP_Shutdown(void)
{
    // do your one time uninitialization here, such as unloading dynamically
    // loaded DLLs
}

void _Optlink Launch_NPLOAD(PVOID param)
{
    APIRET         rc;
    HAB            hab;
    PluginInstance *This;


    This = (PluginInstance *)param;
    hab = WinInitialize(0);
    This->hmq = WinCreateMsgQueue(hab,0);

    WinDlgBox  (HWND_DESKTOP,
                HWND_DESKTOP,
                (PFNWP)NPLoadProc,
                DLLInstance,
                ID_NPLOAD,
                NULL);
    WinDestroyMsgQueue(This->hmq);
    WinTerminate(hab);
    _endthread();
}

void _Optlink Launch_NPUNZIP(PVOID param)
{
    APIRET         rc;
    HAB            hab;
    PluginInstance *This;


    This = (PluginInstance *)param;
    hab = WinInitialize(0);
    This->hmq = WinCreateMsgQueue(hab,0);

    WinDlgBox  (HWND_DESKTOP,
                HWND_DESKTOP,
                (PFNWP)NPUnzipProc,
                DLLInstance,
                ID_NPUNZIP,
                This);
    WinDestroyMsgQueue(This->hmq);
    WinTerminate(hab);
    _endthread();
}
//----------------------------------------------------------------------------
// NPP_New:
//----------------------------------------------------------------------------
NPError NP_LOADDS
NPP_New(NPMIMEType pluginType,
                NPP instance,
                uint16 mode,
                int16 argc,
                char* argn[],
                char* argv[],
                NPSavedData* saved)
{
    PluginInstance *This;

    if (instance == NULL)
        return NPERR_INVALID_INSTANCE_ERROR;

    instance->pdata = NPN_MemAlloc(sizeof(PluginInstance));
    This = (PluginInstance*) instance->pdata;

    if (This == NULL)
        return NPERR_OUT_OF_MEMORY_ERROR;
    //
    // *Developers*: Initialize fields of your plugin
    // instance data here.  If the NPSavedData is non-
    // NULL, you can use that data (returned by you from
    // NPP_Destroy to set up the new plugin instance.
    //

    This->fWindow = 0;
    // mode is NP_EMBED, NP_FULL, or NP_BACKGROUND (see npapi.h)
    This->fMode = mode;
    This->hWnd  = 0;
    This->pSavedInstanceData = saved;
    This->pNext = NULL;
    This->hmq   = 0;
    memcpy(&This->npp,&instance,sizeof(NPP));
    This->total    = 0;
    This->reste = 0;
    return NPERR_NO_ERROR;
}


//-----------------------------------------------------------------------------
// NPP_Destroy:
//-----------------------------------------------------------------------------
NPError NP_LOADDS
NPP_Destroy(NPP instance, NPSavedData** save)
{
    PluginInstance *This;

    if (instance == NULL)
        return NPERR_INVALID_INSTANCE_ERROR;

    This = (PluginInstance*) instance->pdata;

    //
    // *Developers*: If desired, call NP_MemAlloc to create a
    // NPSavedDate structure containing any state information
    // that you want restored if this plugin instance is later
    // recreated.
    //

    if (This != NULL)
    {
        // Remove the subclass for the client window
        if(This->hWnd)
        {
            WinSubclassWindow(This->hWnd, This->lpfnOldWndProc);
        }

        // make some saved instance data if necessary
        if (This->pSavedInstanceData == NULL)
        {
            // make a struct header for the data
            This->pSavedInstanceData =
                (NPSavedData*)NPN_MemAlloc(sizeof (struct _NPSavedData));

            // fill in the struct
            if (This->pSavedInstanceData != NULL)
            {
                This->pSavedInstanceData->len = 0;
                This->pSavedInstanceData->buf = 0;

                // replace the def below and references to it with your data
                #define SIDATA "aSavedInstanceDataBlock"

                // the data
                This->pSavedInstanceData->buf = NPN_MemAlloc(sizeof SIDATA);

                if (This->pSavedInstanceData->buf != NULL)
                {
                    strcpy((char*)This->pSavedInstanceData->buf, SIDATA);
                    This->pSavedInstanceData->len = sizeof SIDATA;
                }
            }
        }

        // save some instance data
        *save = This->pSavedInstanceData;

        NPN_MemFree(instance->pdata);
        instance->pdata = NULL;
    }

    return NPERR_NO_ERROR;
}


//----------------------------------------------------------------------------
// NPP_SetWindow:
//----------------------------------------------------------------------------
NPError NP_LOADDS
NPP_SetWindow(NPP instance, NPWindow* window)
{
    PluginInstance *This;

    if (instance == NULL)
        return NPERR_INVALID_INSTANCE_ERROR;

    This = (PluginInstance*) instance->pdata;

    //
    // *Developers*: Before setting fWindow to point to the
    // new window, you may wish to compare the new window
    // info to the previous window (if any) to note window
    // size changes, etc.
    //
    if ((window->window != NULL) && (This->hWnd == NULL))
    {
        This->fWindow = window;
        This->hWnd    = (HWND)This->fWindow->window;

        // subclass the window
        This->lpfnOldWndProc = WinSubclassWindow(This->hWnd, SubClassFunc);
        AssociateInstance(This->hWnd, This);
        _beginthread(Launch_NPLOAD,NULL,65535,(PVOID)This);
    }
    else
    {
        // if window handle changed
        if (This->hWnd != (HWND)window->window)
        {
            // remember the new window
            This->fWindow = window;

            // Remove the subclass for the old client window
            WinSubclassWindow(This->hWnd, This->lpfnOldWndProc);

            // remember the new window handle
            This->hWnd = (HWND)This->fWindow->window;

            if (This->hWnd != 0)
            {
                // subclass the new one
                This->lpfnOldWndProc = WinSubclassWindow(This->hWnd,
                                                         SubClassFunc);
                AssociateInstance(This->hWnd, This);
            }
        }
    }


    return NPERR_NO_ERROR;
}


//----------------------------------------------------------------------------
// NPP_NewStream:
//----------------------------------------------------------------------------
NPError NP_LOADDS
NPP_NewStream(NPP instance,
              NPMIMEType type,
              NPStream *stream,
              NPBool seekable,
              uint16 *stype)
{
    PluginInstance *This;

    if (instance == NULL)
        return NPERR_INVALID_INSTANCE_ERROR;

    This = (PluginInstance*) instance->pdata;
    This->fichout = fopen("\\tmp.zip","wb");
    This->total   = stream->end;
    This->reste   = stream->end;
    return NPERR_NO_ERROR;
}


//
// *Developers*:
// These next 2 functions are directly relevant in a plug-in which handles the
// data in a streaming manner.  If you want zero bytes because no buffer space
// is YET available, return 0.  As long as the stream has not been written
// to the plugin, Navigator will continue trying to send bytes.  If the plugin
// doesn't want them, just return some large number from NPP_WriteReady(), and
// ignore them in NPP_Write().  For a NP_ASFILE stream, they are still called
// but can safely be ignored using this strategy.
//

//----------------------------------------------------------------------------
// NPP_WriteReady:
//----------------------------------------------------------------------------
int32 NP_LOADDS
NPP_WriteReady(NPP instance, NPStream *stream)
{
    PluginInstance *This;

    if (instance != NULL)
        This = (PluginInstance*) instance->pdata;

    return STREAMBUFSIZE;   // Number of bytes ready to accept in NPP_Write()
}


//----------------------------------------------------------------------------
// NPP_Write:
//----------------------------------------------------------------------------
int32 NP_LOADDS
NPP_Write(NPP instance, NPStream *stream,
          int32 offset, int32 len, void *buffer)
{
   CHAR msg[80];
   PluginInstance *This;

    if (instance != NULL)
       This = (PluginInstance*) instance->pdata;
    This->reste -= len;
    if (This->total > 10000)
      sprintf(msg,"%12d %12d %03d",This->total,This->reste,(( (This->total/10000)-(This->reste/10000) )*100)/(This->total/10000));
    else
      sprintf(msg,"%12d %12d %03d",This->total,This->reste,((This->total-This->reste)*100)/This->total);
    NPN_Status(This->npp,(const char *)msg);
    WinPostQueueMsg(This->hmq,WM_USER,(MPARAM)This->total,(MPARAM)This->reste);
    fwrite(buffer,1,len,This->fichout);
    return len;     // The number of bytes accepted.  Return a
                    // negative number here if, e.g., there was an error
                    // during plugin operation and you want to abort the
                    // stream
}


//----------------------------------------------------------------------------
// NPP_DestroyStream:
//----------------------------------------------------------------------------
NPError NP_LOADDS
NPP_DestroyStream(NPP instance, NPStream *stream, NPError reason)
{
    PluginInstance *This;

    if (instance == NULL)
        return NPERR_INVALID_INSTANCE_ERROR;
    This = (PluginInstance*) instance->pdata;
    WinPostQueueMsg(This->hmq,WM_QUIT,NULL,NULL);
    strcpy(This->filename,stream->url);
    fclose(This->fichout);
    _beginthread(Launch_NPUNZIP,NULL,65535,(PVOID)This);

    return NPERR_NO_ERROR;
}


//----------------------------------------------------------------------------
// NPP_StreamAsFile:
//----------------------------------------------------------------------------
void NP_LOADDS
NPP_StreamAsFile(NPP instance, NPStream *stream, const char* fname)
{
   PluginInstance *This;
   if (instance == NULL)
       return;

   This = (PluginInstance*) instance->pdata;

   // invalidate window to ensure a redraw
   WinInvalidateRect(This->hWnd, 0, TRUE);
}


//----------------------------------------------------------------------------
// NPP_Print:
//----------------------------------------------------------------------------
void NP_LOADDS
NPP_Print(NPP instance, NPPrint* printInfo)
{
;
}


//----------------------------------------------------------------------------
// NPP_HandleEvent:
//----------------------------------------------------------------------------
NPError           NPP_HandleEvent(NPP instance, void* event)
{
    PluginInstance *This;

    NPBool eventHandled = FALSE;
    if (instance == NULL)
        return eventHandled;

    This = (PluginInstance*) instance->pdata;

    //
    // *Developers*: Events will only be passed for Windowless
    // plugins.  The event.event field can be any of the
    // normal WM_ event types, or one of the following additional
    // types defined in npapi.h: getFocusEvent, loseFocusEvent,
    // adjustCursorEvent.  The focus events inform your plugin
    // that it will become, or is no longer, the recepient of
    // key events.  If your plugin doesn't want to receive key
    // events, return false when passed at getFocusEvent.  The
    // adjustCursorEvent is passed repeatedly when the mouse is
    // over your plugin; if your plugin doesn't want to set the
    // cursor, return false.  Handle the standard Mac events as
    // normal.  The return value for all standard events is currently
    // ignored except for the key event: for key events, only return
    // true if your plugin has handled that particular key event.
    //

    return eventHandled;
}


//----------------------------------------------------------------------------
// NPP_URLNotify:
//----------------------------------------------------------------------------
void NP_LOADDS
NPP_URLNotify(NPP instance, const char* url, NPReason reason, void* notifyData)
{
    PluginInstance *This;
    if (instance != NULL)
        This = (PluginInstance*) instance->pdata;
}


//----------------------------------------------------------------------------
// NPP_GetJavaClass:
//----------------------------------------------------------------------------
jref NP_LOADDS
NPP_GetJavaClass(void)
{
  return((jref) 0);
}



//
// Here is a sample subclass function.
//
MRESULT APIENTRY
SubClassFunc(  HWND hWnd,
               ULONG Message,
               MPARAM wParam,
               MPARAM lParam)
{
    HPS            hps;
    PluginInstance *This;
    This = GetInstance(hWnd);

    switch(Message) {
    case WM_REALIZEPALETTE:
        WinInvalidateRect(hWnd, 0, TRUE);
        WinUpdateWindow(hWnd);
        return 0;
        break;
    case WM_PAINT:
        hps   = WinBeginPaint(hWnd,NULLHANDLE,NULL);
        GpiErase(hps);
        WinEndPaint(hWnd);
        break;
    default:
        break;
    }

    return ((PFNWP)This->lpfnOldWndProc)(
                          hWnd,
                          Message,
                          wParam,
                          lParam);
}
